/*******************************************************************************
 * Java2Script Pacemaker (http://j2s.sourceforge.net)
 *
 * Copyright (c) 2006 ognize.com and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ognize.com - initial API and implementation
 *******************************************************************************/

package net.sf.j2s.examples;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import ajax.HttpRequest;

/**
 * @author josson smith
 * 
 * 2006-2-15
 */
public class RSSReader {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		final Display display = new Display();
		Shell shell = new Shell(display);
		shell.setMaximized(true);
		shell.setText("wHizzNotes RSS Reader (J2S AJAX)");
		shell.setLayout(new FillLayout());

		SashForm form = new SashForm(shell, SWT.HORIZONTAL);
		form.setLayout(new FillLayout());

		Composite outlinePanel = new Composite(form, SWT.NONE);
		outlinePanel.setLayout(new FillLayout());
		final Tree outline = new Tree(outlinePanel, SWT.BORDER);
		final String RSS_PREFIX = "http://idwhiz.vicp.net/whizznotes/rss/";
		final String HTML_PREFIX = "http://idwhiz.vicp.net/whizznotes/xhtml/";
		String[] roots = new String[] {
//				"http://idwhiz.vicp.net/whizznotes/rss/all.xml",
				RSS_PREFIX + "1.xml"//,
//				"http://idwhiz.vicp.net/whizznotes/rss/441.xml"
		};
		for (int i=0; i< roots.length; i++) {
			TreeItem root = new TreeItem (outline, 0);
			root.setText ("wHizzNotes");//roots [i].substring(roots[i].lastIndexOf("/") + 1));
			root.setData (roots [i]);
			new TreeItem (root, 0);
		}

		final Composite contentPanel = new Composite(form, SWT.NONE);
		contentPanel.setLayout(new FillLayout());
		final Browser browser = new Browser(contentPanel, SWT.BORDER);

		outline.addListener (SWT.Expand, new Listener () {
			public void handleEvent (final Event event) {
				final TreeItem root = (TreeItem) event.item;
				TreeItem [] items = root.getItems ();
				for (int i= 0; i<items.length; i++) {
					if (items [i].getData () != null) {
						//System.out.println("return ?");
						return;
					}
					//System.out.println("dispose");
					items [i].dispose ();
				}
				String url = (String) root.getData();
				final HttpRequest request = new HttpRequest();
				//request.open("GET", "http://j2s.sourceforge.net/blog/feed/atom/", true);
				request.open("GET", url, true);
				request.registerOnReadyStateChange(new HttpRequestCallBackSWTAdapter() {
					public void swtOnComplete() {
						//System.out.println(request.getResponseText());
						NodeList xitems = request.getResponseXML().getElementsByTagName("item");
						for (int i = 0; i < xitems.getLength(); i++) {
							Element item = (Element) xitems.item(i);
							NodeList titles = item.getElementsByTagName("title");
							Element title = (Element) titles.item(0);
							String titleLabel = title.getFirstChild().getNodeValue();
							//System.out.println(titleLabel);
							
							NodeList htmlURL = item.getElementsByTagName("link");
							Element link = (Element) htmlURL.item(0);
							String url = link.getFirstChild().getNodeValue();
							//System.out.println(url);
							url = RSS_PREFIX + url.substring(url.lastIndexOf("/") + 1, url.lastIndexOf(".")) + ".xml";

//							NodeList desc = item.getElementsByTagName("description");
//							Element description = (Element) desc.item(0);
//							String htmlDesc = description.getFirstChild().getNodeValue();
//							browser.setText("<html><body>" + htmlDesc + "</body></html>");

							//System.out.println(i + ". " + titleLabel);
							TreeItem treeItem = new TreeItem (root, 0);
							treeItem.setText (titleLabel);
							treeItem.setData (url);
							TreeItem t = new TreeItem (treeItem, 0);
							//t.setText("Loading...");
						}
						root.setExpanded(true);
					}
				});
				request.send();
			}
		});

		outline.addSelectionListener(new SelectionAdapter() {
		
			public void widgetSelected(SelectionEvent e) {
				String url = (String) outline.getSelection()[0].getData();
				url = HTML_PREFIX + url.substring(url.lastIndexOf("/") + 1, url.lastIndexOf(".")) + ".html";
				browser.setUrl(url);
//				String selected = outline.getSelection()[0].getText();
//				System.out.println(selected);
//				browser.setText("<html><body><button>" + selected + "</button></body></html>");
			}
		
		});
		
		form.setWeights(new int[] { 32, 68 });
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

}
